#!/usr/bin/python

#   
Settings = '/root/etc/backup.settings';

import os;
import tempfile;
import shutil;
import re;
import md5;
import pickle;
class BaseCopy:
    '    '
    def __init__(self, BacupName):
        '    (  backup)'
        self.BUName = BacupName;
        #import tempfile;
        self.TmpPath = tempfile.mktemp();
        #import os;
        os.makedirs(self.TmpPath);
        self.NeededDir = '';
        self.NDflags = 0;
        self.SuperfluousDir = '/tmp/+|/temp/+';
        self.SDflags = 0;
        self.NeededFile = '';
        self.NFflags = 0;
        self.SuperfluousFile = '.tmp\Z';
        self.SFflags = 0;
        self.BackupPath = '/BackUp';

    def __del__(self):
        import shutil;
        shutil.rmtree(self.TmpPath);


    def SetStoragePath(self, StoragePath):
        self.StorPath = StoragePath;

    def SetOrigPath(self, OriginalPath):
        self.OrigPath = OriginalPath;
        os.chdir(self.OrigPath);

    def SetNeededDir(self, NeededDir):
        self.NeededDir = NeededDir;

    def SetNeededDirFlags(self, NDirflags):
        try:
            self.NDflags = int(NDirflags);
        except ValueError:
            print "Bad regular expression flags (NeededDirFlags): \'", NDirflags, "'\ in ", self.BUName
            self.NDFlags = 0;

    def SetNeededFile(self, NeededFile):
        self.NeededFile = NeededFile;

    def SetNeededFileFlags(self, NFileflags):
        try:
            self.NFflags = int(NFileflags);
        except ValueError:
            print "Bad regular expression flags (NeededFileFlags): \'", NFileflags, "'\ in ", self.BUName
            selfNFflags = 0;

    def SetSuperfluousDir(self, SuperfluousDir):
        self.SuperfluousDir = SuperfluousDir;

    def SetSuperfluousDirFlags(self, SDirflags):
        try:
            self.SDflags = int(SDirflags);
        except ValueError:
            print "Bad regular expression flags (SuperfluousDirFlags): \'", SDirflags, "'\ in ", self.BUName
            self.SDflags = 0;

    def SetSuperfluousFile(self, SuperfluousFile):
        self.SuperfluousFile = SuperfluousFile;

    def SetSuperfluousFileFlags(self, SFileflags):
        try:
            self.SFflags = int(SFileflags);
        except ValueError:
            print "Bad regular expression flags (SuperfluousFileFlags): \'", SFileflags, "'\ in ", self.BUName
            self.SFflags = 0;

    def SetBackupPath(self, BackupPath):
        self.BackupPath = BackupPath;

    def MakeREflags(self, rf):
        '       re.compile'
        re_fl = 0;
        #import re;
        if (rf | 01) == rf:
            re_fl = re_fl | re.IGNORECASE ;
        if (rf | 02) == rf:
            re_fl = re_fl | re.LOCALE ;
        if (rf | 04) == rf:
            re_fl = re_fl | re.MULTILINE ;
        if (rf | 010) == rf:
            re_fl = re_fl | re.DOTALL ;
        if (rf | 020) == rf:
            re_fl = re_fl | re.VERBOSE ;
        if (rf | 040) == rf:
            re_fl = re_fl | re.UNICODE ;
        return re_fl;

    def DirectoryList(self):
        #import os;
        from operator import truth;
        #import re;
        fc = os.popen2('find . -name \'*\' -type d');
        #   DirList  
        self.DirList = fc[1].readlines();
        for i in range(len(self.DirList)):
            self.DirList[i] = self.DirList[i][:-1];
        #    
        if self.NeededDir != '':
            try:
                re_obj = re.compile(self.NeededDir, self.MakeREflags(self.NDflags));
                for x in self.DirList[:]:
                    if not truth(re_obj.search(x)):
                        self.DirList.remove(x);
            except re.error:
                print "Bad regular expression (NeededDir): \'", self.NeededDir, "'\ in ", self.BUName
        #     
        if self.SuperfluousDir != '':
            try:
                re_obj = re.compile(self.SuperfluousDir, self.MakeREflags(self.SDflags));
                for x in self.DirList[:]:
                    if truth(re_obj.search(x)):
                        self.DirList.remove(x);
            except re.error:
                print "Bad regular expression (SuperfluousDir): \'", self.SuperfluousDir, "'\ in ", self.BUName

    def FileList(self):
        #import os;
        from operator import truth;
        #import re;
        fc = os.popen2('find . -name \'*\' -type f');
        #   FileList  
        self.FileList = fc[1].readlines();
        for i in range(len(self.FileList)):
            self.FileList[i] = self.FileList[i][:-1];
        #    
        if self.NeededFile != '':
            try:
                re_obj = re.compile(self.NeededFile, self.MakeREflags(self.NFflags));
                for x in self.FileList[:]:
                    if not truth(re_obj.search(x)):
                        self.FileList.remove(x);
            except re.error:
                print "Bad regular expression (NeededFile): \'", self.NeededFile, "'\ in ", self.BUName
        #     
        if self.SuperfluousFile != '':
            try:
                re_obj = re.compile(self.SuperfluousFile, self.MakeREflags(self.SFflags));
                for x in self.FileList[:]:
                    if truth(re_obj.search(x)):
                        self.FileList.remove(x);
            except re.error:
                print "Bad regular expression (SuperfluousFile): \'", self.SuperfluousFile, "'\ in ", self.BUName

    def DeleteNotLegalPathFile(self):
        '   ,   '
        for x in self.FileList[:]:
            s = os.path.dirname(x);
            if s not in self.DirList :
                if s != '.' :
                    self.FileList.remove(x);

    def MakeTempDir(self):
        #import os;
        #      
        os.chdir(self.TmpPath);
        os.mkdir(self.BUName);
        os.chdir(self.BUName);
        for x in self.DirList:
            os.makedirs(x);
            #   
            stat = os.stat(self.OrigPath + x[1:]);
            #   
            os.chmod(x, stat[0]);
            os.chown(x, stat[4], stat[5]);
            os.utime(x, stat[7:9]);

    def DeleteTempDir(self):
        #import os;
        os.chdir(self.TmpPath);
        if os.access(self.BUName, os.R_OK):
            os.chdir(self.BUName);
            #   
            fc = os.popen2('find . -type f');
            fl = fc[1].readlines();
            for x in fl:
                os.remove(x[:-1]);
            #   
            fc = os.popen2('find . -type l');
            fl = fc[1].readlines();
            if fl:
                fl.sort();
                fl.reverse();
            for x in fl:
                os.remove(x[:-1]);
            #   
            fc = os.popen2('find . -name \'*\' -type d');
            fl = fc[1].readlines();
            if fl:
                fl.sort();
                fl.reverse();
            for x in fl:
                os.rmdir(x[:-1]);
            os.chdir('..');
            os.rmdir(self.BUName);


    def GetMD5(self, FullFileName):
        #  md5     
        #import md5;
        f = open(FullFileName, 'rb');
        result = md5.new(f.read()).hexdigest();
        f.close();
        return result;


    def CreateMD5dist(self):
        #        MD5 

        #  
        self.FileMD5 = {};
        #  
        for x in self.FileList:
            self.FileMD5[x] = self.GetMD5(self.OrigPath + x[1:]);

    def ReadMD5dist(self, FileName):
        #     /MD5
        #import pickle;
        f = open(FileName, 'rb');
        result = pickle.load(f);
        f.close();
        return result;

    def WriteMD5dist(self, FileName, dist):
        #     /MD5
        #import pickle;
        f = open(FileName, 'wb');
        pickle.dump(dist, f);
        f.close();

    def CreateTar(self, SysString):
        self.MakeTempDir();
        tempdir = self.TmpPath + '/' + self.BUName;
        #import shutil;
        for x in self.FileList:
            copyfile = tempdir + x[1:];
            origfile = self.OrigPath + x[1:];
            shutil.copy2(origfile, copyfile);
            ##f = open(origfile, 'rb');
##            fc = open(copyfile, 'wb');
##            fc.write(f.read());
##            f.close();
##            fc.close();
            stat = os.stat(origfile);
            os.chown(copyfile, stat[4], stat[5]);
            #os.utime(copyfile, stat[7:9]);
        os.chdir(self.TmpPath);
        os.system(SysString);
        #self.DeleteTempDir();





class FullCopy(BaseCopy):
    '   '

    def MakeCopy(self):
        #import os;
        os.chdir(self.OrigPath);
        self.DirectoryList();
        self.FileList();
        self.DeleteNotLegalPathFile();
        self.CreateMD5dist();
        self.CreateTar('tar -cpf - --label=\"Full Bacup of the ' + self.BUName + ' created on `date \'+%Y-%m-%d\'`\" ' + self.BUName + ' | bzip2 -c -9 > ' + self.BackupPath + '/' + self.BUName + '-`date \'+%Y-%m-%d\'`.tar.bz2');
        self.WriteMD5dist(self.StorPath + '/' + self.BUName + '.md5.files', self.FileMD5);
        self.WriteMD5dist(self.StorPath + '/' + self.BUName + '.list.directories', self.DirList);
        self.WriteMD5dist(self.StorPath + '/' + self.BUName + '.dir.deleted', []);
        self.WriteMD5dist(self.StorPath + '/' + self.BUName + '.file.deleted', []);


class IncrementCopy(BaseCopy):
    '   '

    def CompareMD5(self):
        #   MD5
        pass;

    def MakeCopy(self):
        #import os;
        os.chdir(self.OrigPath);
        self.DirectoryList();
        self.FileList();
        self.DeleteNotLegalPathFile();
        self.CreateMD5dist();
        #    MD5
        self.OldMD5 = self.ReadMD5dist(self.StorPath + '/' + self.BUName + '.md5.files');
        #    
        self.OldDir = self.ReadMD5dist(self.StorPath + '/' + self.BUName + '.list.directories');
        #     
        self.OldDelDir = self.ReadMD5dist(self.StorPath + '/' + self.BUName + '.dir.deleted');
        #     
        self.OldDelFile = self.ReadMD5dist(self.StorPath + '/' + self.BUName + '.file.deleted');
        #         
        for x in self.OldDelDir[:]:
            if x in self.DirList :
            #if self.DirList.count(x) != 0 :
                self.OldDelDir.remove(x);
        #   
        for x in self.OldDelFile[:]:
            if x in self.FileList :
            #if self.FileList.count(x) != 0 :
                self.OldDelFile.remove(x);
        #     
        for x in self.OldDir:
            if x not in self.DirList :
            #if self.DirList.count(x) == 0:
                self.OldDelDir.append(x);
        #   
        for x in self.OldMD5.keys():
            if not self.FileMD5.has_key(x):
                self.OldDelFile.append(x);
        #   MD5     -   
        for x in self.FileMD5.keys():
            if self.OldMD5.has_key(x):
                if self.FileMD5[x] == self.OldMD5[x]:
                    self.FileList.remove(x);
        #  
        self.CreateTar('tar -cpf - --label=\"Incremental Bacup of the ' + self.BUName + ' created on `date \'+%Y-%m-%d\'`\" ' + self.BUName + ' | bzip2 -c -9 > ' + self.BackupPath + '/' + self.BUName + '-i-`date \'+%Y-%m-%d--%H-%M-%S\'`.tar.bz2');
        self.WriteMD5dist(self.StorPath + '/' + self.BUName + '.md5.files', self.FileMD5);
        self.WriteMD5dist(self.StorPath + '/' + self.BUName + '.list.directories', self.DirList);
        self.WriteMD5dist(self.StorPath + '/' + self.BUName + '.dir.deleted', self.OldDelDir);
        self.WriteMD5dist(self.StorPath + '/' + self.BUName + '.file.deleted', self.OldDelFile);

#################################################################################################################################################

#  
import time;
Day = int(time.strftime('%d',time.localtime(time.time())));

import ConfigParser;
cp = ConfigParser.ConfigParser();
cp.read(Settings);
sections = cp.sections();
DefaultOptions = cp.defaults();
try:
    for cs in sections:
        if Day == 1:
            bu = FullCopy(cs);
        else:
            bu = IncrementCopy(cs);
        bu.SetStoragePath(DefaultOptions['storage_path']);
        bu.SetOrigPath(cp.get(cs, 'path'));

        if cp.has_option(cs, 'needed_directories') :
            bu.SetNeededDir(cp.get(cs, 'needed_directories'));
        else:
            bu.SetNeededDir(DefaultOptions['needed_directories']);

        if cp.has_option(cs, 'n_d_flags') :
            bu.SetNeededDirFlags(cp.get(cs, 'n_d_flags'));
        else:
            bu.SetNeededDirFlags(DefaultOptions['n_d_flags']);

        if cp.has_option(cs, 'needed_files') :
            bu.SetNeededFile(cp.get(cs, 'needed_files'));
        else:
            bu.SetNeededFile(DefaultOptions['needed_files']);

        if cp.has_option(cs, 'n_f_flags') :
            bu.SetNeededFileFlags(cp.get(cs, 'n_f_flags'));
        else:
            bu.SetNeededFileFlags(DefaultOptions['n_f_flags']);

        if cp.has_option(cs, 'superfluous_directories') :
            bu.SetSuperfluousDir(cp.get(cs, 'superfluous_directories'));
        else:
            bu.SetSuperfluousDir(DefaultOptions['superfluous_directories']);

        if cp.has_option(cs, 's_d_flags') :
            bu.SetSuperfluousDirFlags(cp.get(cs, 's_d_flags'));
        else:
            bu.SetSuperfluousDirFlags(DefaultOptions['s_d_flags']);

        if cp.has_option(cs, 'superfluous_files') :
            bu.SetSuperfluousFile(cp.get(cs, 'superfluous_files'));
        else:
            bu.SetSuperfluousFile(DefaultOptions['superfluous_files']);

        if cp.has_option(cs, 's_f_flags') :
            bu.SetSuperfluousFileFlags(cp.get(cs, 's_f_flags'));
        else:
            bu.SetSuperfluousFileFlags(DefaultOptions['s_f_flags']);

        bu.SetBackupPath(DefaultOptions['backup_store_path']);

        bu.MakeCopy();
        del bu
except ConfigParser.NoOptionError, oe:
    print "Option ", oe.option, " not present in section ", oe.section
    import sys;
    sys.exit(2);

